Unit DE37R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE36R_p, UTDE16_p;

procedure DE37R(FA :Proc_F3_DE; FI :Proc_F3_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; HMIN :Real;
                EPS :Real; P :Real; var H :Real;
                var Y :Array of Real; var RAB :Array of Real;
                var IR :Array of Integer; var IERR :Integer);

implementation

procedure DE37R(FA :Proc_F3_DE; FI :Proc_F3_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; HMIN :Real;
                EPS :Real; P :Real; var H :Real;
                var Y :Array of Real; var RAB :Array of Real;
                var IR :Array of Integer; var IERR :Integer);
var
I,JSTART,M22,M3,NR1,NR2,NR3,NR4,NR5 :Integer;
H1,HS,X :Real;
BUL :Boolean;
label
_10,_20,_30,_40,_50;
begin
IERR  := 0;
for I:=1 to M do
 begin
  Y[I-1] := YN[I-1];
_10:
 end;
X  := XN;
if ( XN  =  XK ) 
 then goto _50;
_COM36R.elm1  := 3*M;
M22  := M*M;
NR1  := 2 + M;
NR2  := NR1 + _COM36R.elm1*(_COM36R.elm1 + 1);
NR3  := NR2 + _COM36R.elm1;
NR4  := NR3 + M22;
NR5  := NR4 + M;
H  := Sign(H,XK-XN);
BUL  := False;
JSTART  := 0;
_20:
if ( not  BUL ) 
 then goto _30;
H  := HS;
goto _50;
_30:
H1  := XK - X;
if ( Abs(H1) >  Abs(H) ) 
 then goto _40;
HS  := H;
H  := H1;
BUL  := True;
_40:
DE36R(FA,FI,M,JSTART,HMIN,EPS,P,Y,X,H,BUL,RAB[0],RAB[1],
     IR,RAB[NR1-1],RAB[NR2-1],RAB[NR3-1],RAB[NR4-1],RAB[NR5-1],
     IERR);
if ( IERR  =  0 ) 
 then goto _20;
UTDE16(IERR,37);
_50:
end;

end.
